

import java.awt.*;

import java.util.*;

import java.io.*;



// Entities in a landscape 



public class BaseEntity extends EntityInstance {



    protected static boolean has3Dlook = true;



    public static void set3Dlook(boolean state) {

	has3Dlook = state;

    }



    protected BaseEntity undoEntity; 



    protected BaseEntity() {

    }

      

    public BaseEntity(EntityClass parentClass, String id, Diagram dg) {

	super(parentClass, id, dg);



	undoEntity = new BaseEntity();

    }



    public void saveForUndo() {

	super.saveForUndo(undoEntity);

    }



    public void undo() {

        BaseEntity undoEntity = this.undoEntity;



        this.undoEntity = new BaseEntity(); 

        doSaveForUndo(this.undoEntity); 



	super.undo(undoEntity); 

    }



    public void drawTab(Graphics g, Color c, int tab, boolean fill) {



        double h = Math.min(TAB_HEIGHT, tabHeight());



        ScreenLayout lyt =

            new ScreenLayout(x+width+1, y + ((h+2)*tab), h, h);



        g.setColor(c);



        if (fill) {

            g.fillRect(lyt.x, lyt.y, lyt.width, lyt.height);



            g.setColor(Color.black);

            g.drawRect(lyt.x, lyt.y, lyt.width, lyt.height);

        }

        else {

            g.drawRect(lyt.x, lyt.y, lyt.width, lyt.height);

        }

    }



    protected void setColor(Graphics g) {

	if (highlightFlag && !isOpen()) {

	    g.setColor(Color.red.darker());

	}

	else {

	    g.setColor(getBackground());

	}

    }



    protected void drawFlagAttributes(Graphics g, ScreenLayout rect) {

	if (groupFlag) {

	    // Draw resize points



	    g.setColor(labelColour);



	    int pdim = (rect.height < 20) ? 4 : 6;



	    if (groupKey) {

	        g.fillRect(rect.x+1, rect.y+1, pdim, pdim);

	        g.fillRect(rect.x+rect.width/2-pdim/2, rect.y+1, pdim, pdim);

	        g.fillRect(rect.x+rect.width-pdim, rect.y+1, pdim, pdim);

	        g.fillRect(rect.x+1, rect.y+rect.height/2-pdim/2, pdim, pdim);

	        g.fillRect(rect.x+rect.width-pdim, rect.y+rect.height/2-pdim/2, 

				pdim, pdim);

	        g.fillRect(rect.x+1, rect.y+rect.height-pdim, pdim, pdim);

	        g.fillRect(rect.x+rect.width/2-pdim/2, rect.y+rect.height-pdim, 

				pdim, pdim);

	        g.fillRect(rect.x+rect.width-pdim, rect.y+rect.height-pdim, 

				pdim, pdim);

	    }

	    else {

	        g.drawRect(rect.x+1, rect.y+1, pdim, pdim);

	        g.drawRect(rect.x+rect.width/2-pdim/2, rect.y+1, pdim, pdim);

	        g.drawRect(rect.x+rect.width-pdim, rect.y+1, pdim, pdim);

	        g.drawRect(rect.x+1, rect.y+rect.height/2-pdim/2, pdim, pdim);

	        g.drawRect(rect.x+rect.width-pdim, rect.y+rect.height/2-pdim/2, 

				pdim, pdim);

	        g.drawRect(rect.x+1, rect.y+rect.height-pdim, pdim, pdim);

	        g.drawRect(rect.x+rect.width/2-pdim/2, rect.y+rect.height-pdim, 

				pdim, pdim);

	        g.drawRect(rect.x+rect.width-pdim, rect.y+rect.height-pdim, 

				pdim, pdim);

	    }

	}

    }



    public void draw(Graphics g) {

    }



    // Assuming p1 is in this object and p2 is outside,

    // return the point that is the intersection between this object 

    // and the line segment p1->p2.



    public RealPoint calculateIntercept(RealPoint p1, RealPoint p2) {

	double x = 0.0;

	double y = 0.0;



	double t, b, l, r;  // Top, bottom, left, and right



	t = this.y-1;

	b = this.y + this.height + 1;

	l = this.x - 1;

	r = this.x + this.width + 1;



	boolean found = true;



	if (p1.x < l || p1.x > r || p1.y < t || p1.y > b) {

	    MsgOut.println("calculateIntercept: p1 is not in box");

	    return new RealPoint(x, y);

	}



	if (p1.x == p2.x && p1.y == p2.y) {

	    MsgOut.println("calculateIntercept: p1 == p2");

	    return new RealPoint(x, y);

	}



	if (r <= p2.x)

	    x = r;

	else if (p2.x < l)

	    x = l;

	else

	    found = false;



	if (found) {

	    // y = mx + b

	    y = p1.y + (x - p1.x) * ( (p2.y - p1.y) / (p2.x - p1.x) );

	    found = ( t <= y && y <= b );

	}



	if (!found) {

	    found = true;

	    if (p2.y <= t)

		y = t;

	    else if (p2.y >= b)

		y = b;

	    else

		found = false;



	    if (found) {

		x = p1.x + (y - p1.y) * ( (p2.x - p1.x) / (p2.y - p1.y) );

		found = (l <= x && x <= r);

	    }

	}



	if (!found) {

	    MsgOut.println("calculateIntercept failed: " + 

		p1.x + " " + p1.y + " " + p2.x + " " + p2.y); 

	}



	return new RealPoint(x, y);

    }



    public boolean isPointOver(int x, int y, ScreenLayout lyt) {

	return lyt.inside(x, y);

    }



    public boolean isPointOver(int x, int y) {

        ScreenLayout rect = new ScreenLayout(getLayout());



        return isPointOver(x, y, rect);

    }



    public int overResizeTab(int x, int y) {



	ScreenLayout rect = 

	    new ScreenLayout(this.x+6, this.y+6, width-12, height-12);



        if (isPointOver(x, y, rect))

	    return RSZ_NONE;



	rect = new ScreenLayout(this.x, this.y, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_NW;



	rect = new ScreenLayout(this.x+width/2-3, this.y, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_N;



	rect = new ScreenLayout(this.x+width-6, this.y, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_NE;



	rect = new ScreenLayout(this.x, this.y+height/2-3, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_W;



	rect = new ScreenLayout(this.x+width-6, this.y+height/2-3, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_E;



	rect = new ScreenLayout(this.x, this.y+this.height-6, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_SW;



	rect = new ScreenLayout(this.x+width/2-3, this.y+height-6, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_S;



	rect = new ScreenLayout(this.x+width-6, this.y+height-6, 6, 6);



        if (isPointOver(x, y, rect))

	    return RSZ_SE;



	return RSZ_NONE;

    }



    public boolean isPointOverTab(int x, int y, int tab) {

        double h = Math.min(TAB_HEIGHT, tabHeight());



        ScreenLayout lyt =

            new ScreenLayout(this.x+width+1, this.y + ((h+4)*tab), h, h);

 

	return (x >= lyt.x && x < lyt.x+lyt.width &&

                y >= lyt.y && y < lyt.y+lyt.height);

    }



    public boolean isPointOverIO(EdgePoint pt, int x, int y) {

        ScreenPoint spt = new ScreenPoint(pt.x, pt.y);



	return ((spt.x - Bend.SIZE/2) < x && x < (spt.x + Bend.SIZE/2) &&

	        (spt.y - Bend.SIZE/2) < y && y < (spt.y + Bend.SIZE/2));

    }

 

    public boolean containsLayout(Layout lyt) {

	return (x < lyt.x && lyt.x+lyt.width < x+width &&

		y < lyt.y && lyt.y+lyt.height < y+height); 

    }



    public boolean intersectsLayout(Layout lyt) {

	// Return true if the intersection of passed layout and 

	// entities layout is non-null



	// It overlaps if any corner of layout is contained in

	// entity, or vice versa.



	ScreenLayout rgn = new ScreenLayout(lyt); 

	ScreenLayout box = new ScreenLayout(this.x, this.y, width, height);



	return rgn.intersects(box);

    }



    public void drawHighlight(Graphics g) {

        g.setColor(Color.white);



	ScreenLayout rect = new ScreenLayout(x, y, width, height);



        g.drawRect(rect.x, rect.y, rect.width, rect.height);

        g.drawRect(rect.x+1, rect.y+1, rect.width-1, rect.height-1);

    }



    public void undrawHighlight(Graphics g) {

        setColor(g);



	ScreenLayout rect = new ScreenLayout(x, y, width, height);



        g.draw3DRect(rect.x, rect.y, rect.width, rect.height, true);

        g.draw3DRect(rect.x+1, rect.y+1, rect.width-1, rect.height-1, true);

    }



    public void drawOutline(Graphics g, Layout lyt) {

	ScreenLayout rect = new ScreenLayout(lyt); 



	g.drawRect(rect.x, rect.y, rect.width, rect.height);

	// g.drawRect(rect.x-1, rect.y-1, rect.width+1, rect.height+1);

    }



    protected EdgePoint 

    getPoint(EdgePoint[] pts, RelationClass rc, int side) {

	int nid = rc.getNid();



	// Cache calculated points



	if (pts[nid] == null) {

	    Attribute attr = rc.getAttribute(RelationClass.FACTOR_ID);



	    double f = rc.getIOfactor();



	    double wf = 0.0;

	    double hf = 0.0;



	    switch(side)

	    {

	    case EdgePoint.TOP:

		wf = f;

		hf = 0.0;

		break;



	    case EdgePoint.BOTTOM:

		wf = f;

		hf = 1.0;

		break;



	    case EdgePoint.LEFT:

		wf = 0.0;

		hf = f;

		break;



	    default:

		wf = 1.0;

		hf = f;

		break;

	    }



	    pts[nid] = new EdgePoint(this, rc, wf, hf);

	    pts[nid].rescale();

	    pts[nid].isDefault = true;

	    pts[nid].side = side;

	}



	return pts[nid];

    }



    public EdgePoint getPoint(RelationClass rc, int side) {



	switch(side)

	{

	case EdgePoint.TOP:

	    if (topPoints == null)

		topPoints = new EdgePoint[dg.numRelationClasses()];



	    return getPoint(topPoints, rc, side);



	case EdgePoint.BOTTOM:

	    if (bottomPoints == null)

		bottomPoints = new EdgePoint[dg.numRelationClasses()];



	    return getPoint(bottomPoints, rc, side);



	case EdgePoint.LEFT:

	    if (leftPoints == null)

		leftPoints = new EdgePoint[dg.numRelationClasses()];



	    return getPoint(leftPoints, rc, side);



	default:

	    if (rightPoints == null)

		rightPoints = new EdgePoint[dg.numRelationClasses()];



	    return getPoint(rightPoints, rc, side);

	}

    }



    public EdgePoint getOutPoint(RelationInstance ri,

			int edge_mode, Layout srcLyt, Layout dstLyt) 

    {

	RelationClass rc = ri.getRelationClass();



	int nid = rc.getNid();





	switch(edge_mode)

	{

	case Diagram.TB_EDGE:

	    {

	    BaseEntity src = (BaseEntity) ri.getSrc();



	    if (this == src || src.isContainedBy(this)) {

		if (bottomPoints == null)

		    bottomPoints = new EdgePoint[dg.numRelationClasses()];



		return getPoint(bottomPoints, rc, EdgePoint.BOTTOM);

	    }



	    if (topPoints == null) 

		topPoints = new EdgePoint[dg.numRelationClasses()];



	    return getPoint(topPoints, rc, EdgePoint.TOP);

	    }



	default:

	    if ((dstLyt.y - (srcLyt.y+srcLyt.height)) > SEP_THRESHOLD) {

		if (bottomPoints == null)

		    bottomPoints = new EdgePoint[dg.numRelationClasses()];



		return getPoint(bottomPoints, rc, EdgePoint.BOTTOM);

	    }

	    else if ((srcLyt.y - (dstLyt.y+dstLyt.height)) > SEP_THRESHOLD) {

		if (topPoints == null)

		    topPoints = new EdgePoint[dg.numRelationClasses()];



		return getPoint(topPoints, rc, EdgePoint.TOP);

	    }

	    else if ((dstLyt.x - (srcLyt.x+srcLyt.width)) > SEP_THRESHOLD) {

		if (rightPoints == null)

		    rightPoints = new EdgePoint[dg.numRelationClasses()];



		return getPoint(rightPoints, rc, EdgePoint.RIGHT);

	    }

	    else if ((srcLyt.x - (dstLyt.x+dstLyt.width)) > SEP_THRESHOLD) {

		if (leftPoints == null)

		    leftPoints = new EdgePoint[dg.numRelationClasses()];



		return getPoint(leftPoints, rc, EdgePoint.LEFT);

	    }

	    else if (dstLyt.y > (srcLyt.y+srcLyt.height)) {

		if (bottomPoints == null)

		    bottomPoints = new EdgePoint[dg.numRelationClasses()];



		return getPoint(bottomPoints, rc, EdgePoint.BOTTOM);

	    }



	    if (topPoints == null) 

		topPoints = new EdgePoint[dg.numRelationClasses()];



	    return getPoint(topPoints, rc, EdgePoint.TOP);

	}

    }



    protected EdgePoint testMouseOverIO(EdgePoint[] pts, int x, int y) {

	if (pts == null)

	    return null;



	for (int i = 0; i < pts.length; i++) {

	    EdgePoint pt = pts[i];



	    if (pt != null) {

		if (isPointOverIO(pt, x, y))

		    return pt;

	    }

	}



	return null;

    }



    public EdgePoint getMouseOverIO(int x, int y) {

	EdgePoint pt = testMouseOverIO(topPoints, x, y);



	if (pt != null)

	    return pt;



	pt = testMouseOverIO(bottomPoints, x, y);



	if (pt != null)

	    return pt;



	pt = testMouseOverIO(leftPoints, x, y);



	if (pt != null)

	    return pt;



	return testMouseOverIO(rightPoints, x, y);

    }



    protected void writePoints(PrintStream ps, EdgePoint[] pts, String name) {

	if (pts == null)

	    return;



	boolean isDefault = true;



	for (int i = 1; i < pts.length; i++) {

	    if (pts[i] != null)

		isDefault = isDefault && pts[i].isDefault;

	}



	if (isDefault) {

	    return;

	}



	ps.print("  " + name + " = ( ");

	

	for (int i = 1; i < pts.length; i++) {

	    if (pts[i] != null && !pts[i].isDefault) {

		ps.print("(" + pts[i].rc.getId() + " " +

				pts[i].wf + " " + pts[i].hf + ") ");

	    }

	}



	ps.print(")\n");

    }



    public void writeIOpoints(PrintStream ps) {

	writePoints(ps, topPoints, INPOINT_ID);

	writePoints(ps, bottomPoints, OUTPOINT_ID);

	writePoints(ps, leftPoints, LEFTPOINT_ID);

	writePoints(ps, rightPoints, RIGHTPOINT_ID);

    }

}

